/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.39 Revision 1.55
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.39 2006/10/20 14:44:01 chtekk Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.55 2007/01/03 15:27:13 vivo Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
4 7
5# Author: Francesco Riosa <vivo@gentoo.org> 8# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 9# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7 10
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
9# Note that MYSQL_VERSION_ID must be empty !!! 11# Note that MYSQL_VERSION_ID must be empty !!!
10 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15inherit eutils flag-o-matic gnuconfig autotools mysql_fx
16
17# avoid running userspace code 8 times per ebuild :(
18if [[ "${_MYPVR}" != "${PVR}" ]] || [[ -z "${MYSQL_VERSION_ID}" ]]
19then
20 _MYPVR=${PVR}
21
22 [[ -z ${MY_EXTRAS_VER} ]] && MY_EXTRAS_VER="20070103"
23
24 if [[ ${PR#r} -lt 60 ]] ; then
25 IS_BITKEEPER=0
26 elif [[ ${PR#r} -lt 90 ]] ; then
27 IS_BITKEEPER=60
28 else
29 IS_BITKEEPER=90
30 fi
31
11# MYSQL_VERSION_ID will be: 32 # MYSQL_VERSION_ID will be:
12# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 33 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
13# This is an important part, because many of the choices the MySQL ebuild will do 34 # This is an important part, because many of the choices the MySQL ebuild will do
14# depend on this variable. 35 # depend on this variable.
15# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 36 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
16 37 MYSQL_VERSION_ID=""
17if [[ -z "${MYSQL_VERSION_ID}" ]] ; then
18 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 38 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
19 for vatom in 0 1 2 3 ; do 39 for vatom in 0 1 2 3 ; do
20 # pad to length 2 40 # pad to length 2
21 tpv[${vatom}]="00${tpv[${vatom}]}" 41 tpv[${vatom}]="00${tpv[${vatom}]}"
22 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 42 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
23 done 43 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH) 44 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 45 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi
27 46
28DEPEND="${DEPEND} 47 # Be warned, *DEPEND are version-dependant
29 >=sys-libs/readline-4.1
30 berkdb? ( sys-apps/ed )
31 ssl? ( >=dev-libs/openssl-0.9.6d ) 48 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps ) 49 userland_GNU? ( sys-process/procps )
33 >=sys-libs/zlib-1.2.3 50 >=sys-apps/sed-4
34 >=sys-apps/texinfo-4.7-r1 51 >=sys-apps/texinfo-4.7-r1
35 >=sys-apps/sed-4" 52 >=sys-libs/readline-4.1
53 >=sys-libs/zlib-1.2.3"
36 54
37RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )" 55 # having different flavours at the same time is not a good idea
56 for i in "" "-community" "-slotted" ; do
57 [[ "${i}" == ${PN#mysql} ]] ||
58 DEPEND="${DEPEND} !dev-db/mysql${i}"
59 done
38 60
61 mysql_version_is_at_least "5.1" \
62 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
63
39# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 64 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL
40PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 65 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
41 66
42inherit eutils flag-o-matic gnuconfig autotools mysql_fx 67 if mysql_version_is_at_least "5.1.12" ; then
68 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
69 fi
43 70
44# Shorten the path because the socket path length must be shorter than 107 chars 71 # Shorten the path because the socket path length must be shorter than 107 chars
45# and we will run a mysql server during test phase 72 # and we will run a mysql server during test phase
46S="${WORKDIR}/${PN}" 73 S="${WORKDIR}/mysql"
47 74
48# Define $MY_FIXED_PV for MySQL patchsets 75 # BitKeeper dependency, compile-time only
49MY_FIXED_PV="${PV/_alpha/}" 76 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
50#MY_FIXED_PV="${MY_FIXED_PV/_beta/}"
51#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
52 77
53MY_P="${P/_/-}" 78 if [[ ${PN} == "mysql-slotted" ]] ; then
79 DEPEND="${DEPEND} app-admin/eselect-mysql"
80 fi
54 81
82 if [[ ${PN} == "mysql-slotted" ]] ; then
83 SLOT=""
84 tpv=( ${PV//[-._]/ } )
85 for vatom in 0 1 2 ; do
86 SLOT="${SLOT}${tpv[${vatom}]}_"
87 done
88 #finally SLOT=5_0_24
89 SLOT=${SLOT:0:${#SLOT}-1}
90 else
91 SLOT="0"
92 fi
93
55# Define correct SRC_URIs 94 # Define correct SRC_URIs
56SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${MY_P}${MYSQL_RERELEASE}.tar.gz" 95 SRC_URI="
57if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then 96 ${SERVER_URI}
58 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2" 97 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
59 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball 98 "
60 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}" 99 mysql_version_is_at_least "5.1.12" \
61fi 100 && [[ -n "${PBXT_VERSION}" ]] \
101 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
62 102
63DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 103 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
64HOMEPAGE="http://www.mysql.com/" 104 HOMEPAGE="http://www.mysql.com/"
65SLOT="0"
66LICENSE="GPL-2" 105 LICENSE="GPL-2"
67IUSE="big-tables debug embedded minimal perl selinux srvdir ssl static" 106 IUSE="big-tables debug embedded minimal perl selinux ssl static"
68RESTRICT="confcache" 107 RESTRICT="confcache"
69 108
70mysql_version_is_at_least "4.01.00.00" \ 109 mysql_version_is_at_least "4.1" \
71&& IUSE="${IUSE} latin1" 110 && IUSE="${IUSE} latin1"
72 111
73mysql_version_is_at_least "4.01.03.00" \ 112 mysql_version_is_at_least "4.1.3" \
74&& IUSE="${IUSE} cluster extraengine" 113 && IUSE="${IUSE} cluster extraengine"
75 114
76mysql_version_is_at_least "5.00.00.00" \ 115 mysql_version_is_at_least "5.0" \
77|| IUSE="${IUSE} raid" 116 || IUSE="${IUSE} raid"
78 117
79mysql_version_is_at_least "5.00.18.00" \ 118 mysql_version_is_at_least "5.0.18" \
80&& IUSE="${IUSE} max-idx-128" 119 && IUSE="${IUSE} max-idx-128"
81 120
82mysql_version_is_at_least "5.01.00.00" \ 121 mysql_version_is_at_least "5.1" \
83&& IUSE="${IUSE} innodb" 122 && IUSE="${IUSE} innodb"
84 123
85mysql_version_is_at_least "5.01.00.00" \ 124 mysql_version_is_at_least "5.1" \
86|| IUSE="${IUSE} berkdb" 125 || IUSE="${IUSE} berkdb"
126
127 mysql_version_is_at_least "5.1.12" \
128 && IUSE="${IUSE} pbxt"
129
130 RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
131
132fi # if [[ "${_MYPVR}" != "${PVR}" ]]
87 133
88EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 134EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
89 pkg_postinst pkg_config pkg_postrm 135 pkg_postinst pkg_config pkg_postrm
90 136
91# 137#
92# HELPER FUNCTIONS: 138# HELPER FUNCTIONS:
93# 139#
140
141bitkeeper_fetch() {
142
143 local tpv=( ${PV//[-._]/ } )
144 local reposuf="${tpv[0]}.${tpv[1]}"
145 useq "cluster" && reposuf="${reposuf}-ndb"
146 local repo_uri="bk://mysql.bkbits.net/mysql-${reposuf}"
147 ## -- ebk_store_dir: bitkeeper sources store directory
148 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
149 ## -- ebk_fetch_cmd: bitkeeper fetch command
150 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
151 # hint: does not work
152 local ebk_fetch_cmd="sfioball"
153 ## -- ebk_update_cmd: bitkeeper update command
154 local ebk_update_cmd="update"
155
156 #addread "/etc/bitkeeper"
157 addwrite "${ebk_store_dir}"
158
159 if [[ ! -d "${ebk_store_dir}" ]]; then
160 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory"
161 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}."
162 fi
163
164 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}"
165
166 local wc_path=mysql-${reposuf}
167
168 if [[ ! -d "${wc_path}" ]]; then
169 local options="-r+"
170 # first check out
171 einfo "bitkeeper check out start -->"
172 einfo " repository: ${repo_uri}"
173 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \
174 || die "${EBK}: can't fetch from ${repo_uri}."
175 else
176 if [[ ! -d "${wc_path}/BK" ]]; then
177 popd
178 die "Look like ${wc_path} is not a bitkeeper path."
179 fi
180
181 # update working copy
182 einfo "bitkeeper update start -->"
183 einfo " repository: ${repo_uri}"
184
185 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
186 || die "BK: can't update from ${repo_uri} to ${wc_path}."
187
188 fi
189
190 einfo " working copy: ${wc_path}"
191 cd "${wc_path}"
192 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}."
193
194 echo
195 popd
196
197}
198
199mysql_disable_test() {
200 local testname="${1}" ; shift
201 local reason="${@}"
202 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
203 echo ${testname} : ${reason} >> "${mysql_disable_file}"
204 ewarn "test \"${testname}\" disabled because: \"${reason}\""
205}
94 206
95# void mysql_init_vars() 207# void mysql_init_vars()
96# 208#
97# Initialize global variables 209# Initialize global variables
98# 2005-11-19 <vivo@gentoo.org> 210# 2005-11-19 <vivo@gentoo.org>
99 211
100mysql_init_vars() { 212mysql_init_vars() {
213 if [[ ${SLOT} == "0" ]] ; then
214 MY_SUFFIX=""
215 else
216 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
217 fi
101 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"} 218 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"}
102 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"} 219 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"}
103 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 220 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"}
104 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 221 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"}
105 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"} 222 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"}
106 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"} 223 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"}
107 224
108 if [[ -z "${DATADIR}" ]] ; then 225 if [[ -z "${DATADIR}" ]] ; then
109 DATADIR="" 226 DATADIR=""
110 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 227 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
111 DATADIR=`"my_print_defaults" mysqld 2>/dev/null \ 228 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \
112 | sed -ne '/datadir/s|^--datadir=||p' \ 229 | sed -ne '/datadir/s|^--datadir=||p' \
113 | tail -n1` 230 | tail -n1`
114 if [[ -z "${DATADIR}" ]] ; then 231 if [[ -z "${DATADIR}" ]] ; then
115 if useq "srvdir" ; then
116 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
117 else
118 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 232 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
119 | sed -e 's/.*=\s*//'` 233 | sed -e 's/.*=\s*//'`
120 fi
121 fi 234 fi
122 fi 235 fi
123 if [[ -z "${DATADIR}" ]] ; then 236 if [[ -z "${DATADIR}" ]] ; then
124 if useq "srvdir" ; then
125 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
126 else
127 DATADIR="${MY_LOCALSTATEDIR}" 237 DATADIR="${MY_LOCALSTATEDIR}"
128 fi
129 einfo "Using default DATADIR" 238 einfo "Using default DATADIR"
130 fi 239 fi
131 elog "MySQL DATADIR is ${DATADIR}" 240 elog "MySQL DATADIR is ${DATADIR}"
132 241
133 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 242 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
140 fi 249 fi
141 export PREVIOUS_DATADIR 250 export PREVIOUS_DATADIR
142 fi 251 fi
143 fi 252 fi
144 253
254 MY_SOURCEDIR=${SERVER_URI##*/}
255 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
256
145 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 257 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR
146 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 258 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
147 export MY_INCLUDEDIR 259 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR
148 export DATADIR
149} 260}
150 261
151configure_minimal() { 262configure_minimal() {
152 # These are things we exclude from a minimal build, please 263 # These are things we exclude from a minimal build, please
153 # note that the server actually does get built and installed, 264 # note that the server actually does get built and installed,
154 # but we then delete it before packaging. 265 # but we then delete it before packaging.
155 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 266 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
156 267
157 for i in ${minimal_exclude_list} ; do 268 for i in ${minimal_exclude_list} ; do
158 myconf="${myconf} --without-${i}" 269 myconf="${myconf} --without-${i}"
159 done 270 done
160 myconf="${myconf} --with-extra-charsets=none" 271 myconf="${myconf} --with-extra-charsets=none"
272 myconf="${myconf} --enable-local-infile"
273
274 if useq "static" ; then
275 myconf="${myconf} --with-client-ldflags=-all-static"
276 myconf="${myconf} --disable-shared"
277 else
278 myconf="${myconf} --enable-shared --enable-static"
279 fi
280
281 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
282 myconf="${myconf} --with-charset=utf8"
283 myconf="${myconf} --with-collation=utf8_general_ci"
284 else
285 myconf="${myconf} --with-charset=latin1"
286 myconf="${myconf} --with-collation=latin1_swedish_ci"
287 fi
161} 288}
162 289
163configure_common() { 290configure_common() {
164 myconf="${myconf} $(use_with big-tables)" 291 myconf="${myconf} $(use_with big-tables)"
165 myconf="${myconf} --enable-local-infile" 292 myconf="${myconf} --enable-local-infile"
166 myconf="${myconf} --with-extra-charsets=all" 293 myconf="${myconf} --with-extra-charsets=all"
167 myconf="${myconf} --with-mysqld-user=mysql" 294 myconf="${myconf} --with-mysqld-user=mysql"
168 myconf="${myconf} --with-server" 295 myconf="${myconf} --with-server"
169 myconf="${myconf} --with-unix-socket-path='/var/run/mysqld/mysqld.sock'" 296 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
170 myconf="${myconf} --without-libwrap" 297 myconf="${myconf} --without-libwrap"
171 298
172 if useq "static" ; then 299 if useq "static" ; then
173 myconf="${myconf} --with-mysqld-ldflags=-all-static" 300 myconf="${myconf} --with-mysqld-ldflags=-all-static"
174 myconf="${myconf} --with-client-ldflags=-all-static" 301 myconf="${myconf} --with-client-ldflags=-all-static"
179 306
180 if useq "debug" ; then 307 if useq "debug" ; then
181 myconf="${myconf} --with-debug=full" 308 myconf="${myconf} --with-debug=full"
182 else 309 else
183 myconf="${myconf} --without-debug" 310 myconf="${myconf} --without-debug"
184 mysql_version_is_at_least "4.01.03.00" \ 311 mysql_version_is_at_least "4.1.3" \
185 && useq "cluster" \ 312 && useq "cluster" \
186 && myconf="${myconf} --without-ndb-debug" 313 && myconf="${myconf} --without-ndb-debug"
187 fi 314 fi
188 315
189 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 316 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then
190 myconf="${myconf} --with-charset=utf8" 317 myconf="${myconf} --with-charset=utf8"
191 myconf="${myconf} --with-collation=utf8_general_ci" 318 myconf="${myconf} --with-collation=utf8_general_ci"
192 else 319 else
193 myconf="${myconf} --with-charset=latin1" 320 myconf="${myconf} --with-charset=latin1"
194 myconf="${myconf} --with-collation=latin1_swedish_ci" 321 myconf="${myconf} --with-collation=latin1_swedish_ci"
208 myconf="${myconf} $(use_with perl bench)" 335 myconf="${myconf} $(use_with perl bench)"
209 myconf="${myconf} --enable-assembler" 336 myconf="${myconf} --enable-assembler"
210 myconf="${myconf} --with-extra-tools" 337 myconf="${myconf} --with-extra-tools"
211 myconf="${myconf} --with-innodb" 338 myconf="${myconf} --with-innodb"
212 myconf="${myconf} --without-readline" 339 myconf="${myconf} --without-readline"
213 mysql_version_is_at_least "5.00.00.00" || myconf="${myconf} $(use_with raid)" 340 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
214 341
215 if useq "ssl" ; then 342 if useq "ssl" ; then
216 # --with-vio is not needed anymore, it's on by default and 343 # --with-vio is not needed anymore, it's on by default and
217 # has been removed from configure 344 # has been removed from configure
218 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 345 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
219 if mysql_version_is_at_least "5.00.06.00" ; then 346 if mysql_version_is_at_least "5.0.6" ; then
220 # myconf="${myconf} --with-yassl" 347 # myconf="${myconf} --with-yassl"
221 myconf="${myconf} --with-openssl" 348 myconf="${myconf} --with-openssl"
222 else 349 else
223 myconf="${myconf} --with-openssl" 350 myconf="${myconf} --with-openssl"
224 fi 351 fi
238 else 365 else
239 myconf="${myconf} --without-berkeley-db" 366 myconf="${myconf} --without-berkeley-db"
240 fi 367 fi
241 fi 368 fi
242 369
243 if mysql_version_is_at_least "4.01.03.00" ; then 370 if mysql_version_is_at_least "4.1.3" ; then
244 myconf="${myconf} --with-geometry" 371 myconf="${myconf} --with-geometry"
245 myconf="${myconf} $(use_with cluster ndbcluster)" 372 myconf="${myconf} $(use_with cluster ndbcluster)"
246 fi 373 fi
247 374
248 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then 375 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then
249 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 376 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
250 myconf="${myconf} --with-archive-storage-engine" 377 myconf="${myconf} --with-archive-storage-engine"
251 378
252 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 379 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
253 myconf="${myconf} --with-csv-storage-engine" 380 myconf="${myconf} --with-csv-storage-engine"
256 myconf="${myconf} --with-blackhole-storage-engine" 383 myconf="${myconf} --with-blackhole-storage-engine"
257 384
258 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html 385 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
259 # http://dev.mysql.com/doc/mysql/en/federated-description.html 386 # http://dev.mysql.com/doc/mysql/en/federated-description.html
260 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 387 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
261 if mysql_version_is_at_least "5.00.03.00" ; then 388 if mysql_version_is_at_least "5.0.3" ; then
262 elog "Before using the Federated storage engine, please be sure to read" 389 elog "Before using the Federated storage engine, please be sure to read"
263 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 390 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
264 myconf="${myconf} --with-federated-storage-engine" 391 myconf="${myconf} --with-federated-storage-engine"
265 fi 392 fi
266 fi 393 fi
267 394
268 mysql_version_is_at_least "5.00.18.00" \ 395 mysql_version_is_at_least "5.0.18" \
269 && useq "max-idx-128" \ 396 && useq "max-idx-128" \
270 && myconf="${myconf} --with-max-indexes=128" 397 && myconf="${myconf} --with-max-indexes=128"
271} 398}
272 399
273configure_51() { 400configure_51() {
274 # TODO : !!!!! readd --withouth-readline 401 # TODO: !!!! readd --without-readline
275 # the failure depend upon config/ac-macros/readline.m4 checking into 402 # the failure depend upon config/ac-macros/readline.m4 checking into
276 # readline.h instead of history.h 403 # readline.h instead of history.h
277 myconf="${myconf} $(use_with ssl)" 404 myconf="${myconf} $(use_with ssl)"
278 myconf="${myconf} --enable-assembler" 405 myconf="${myconf} --enable-assembler"
279 myconf="${myconf} --with-geometry" 406 myconf="${myconf} --with-geometry"
286 # 5.1 introduces a new way to manage storage engines (plugins) 413 # 5.1 introduces a new way to manage storage engines (plugins)
287 # like configuration=none 414 # like configuration=none
288 local plugins="csv,myisam,myisammrg,heap" 415 local plugins="csv,myisam,myisammrg,heap"
289 if useq "extraengine" ; then 416 if useq "extraengine" ; then
290 # like configuration=max-no-ndb, archive and example removed in 5.1.11 417 # like configuration=max-no-ndb, archive and example removed in 5.1.11
291 plugins="${plugins},blackhole,federated,ftexample,partition" 418 plugins="${plugins},archive,blackhole,example,federated,partition"
292 419
293 elog "Before using the Federated storage engine, please be sure to read" 420 elog "Before using the Federated storage engine, please be sure to read"
294 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 421 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
295 fi 422 fi
296 423
305 fi 432 fi
306 433
307 myconf="${myconf} --with-plugins=${plugins}" 434 myconf="${myconf} --with-plugins=${plugins}"
308} 435}
309 436
437pbxt_src_compile() {
438 mysql_init_vars
439
440 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
441
442 einfo "Reconfiguring dir '${PWD}'"
443 AT_GNUCONF_UPDATE="yes" eautoreconf
444
445 local myconf
446 myconf="${myconf} --with-mysql=${S}"
447 mkdir -p ${T}/lib
448 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}"
449 useq "debug" && myconf="${myconf} --with-debug=full"
450 # TODO is safe/needed to use econf here ?
451 ./configure ${myconf} || die "problem configuring pbxt storage engine"
452 # TODO is safe/needed to use emake here ?
453 make || die "problem making pbxt storage engine (${myconf})"
454
455 popd
456 # TODO: modify test suite
457}
458
459pbxt_src_install() {
460 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
461 make install || die "failed pbxt install"
462 popd
463}
464
310# 465#
311# EBUILD FUNCTIONS 466# EBUILD FUNCTIONS
312# 467#
313 468
314mysql_pkg_setup() { 469mysql_pkg_setup() {
315 enewgroup mysql 60 || die "problem adding 'mysql' group" 470 enewgroup mysql 60 || die "problem adding 'mysql' group"
316 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 471 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
317
318 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then
319 eerror "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
320 die "InnoDB now uses cmake to build, this is a TODO item, will be fixed shortly!"
321 fi
322 472
323 # Check for USE flag problems in pkg_setup 473 # Check for USE flag problems in pkg_setup
324 if useq "static" && useq "ssl" ; then 474 if useq "static" && useq "ssl" ; then
325 eerror "MySQL does not support being built statically with SSL support enabled!" 475 eerror "MySQL does not support being built statically with SSL support enabled!"
326 die "MySQL does not support being built statically with SSL support enabled!" 476 die "MySQL does not support being built statically with SSL support enabled!"
327 fi 477 fi
328 478
329 if ! mysql_version_is_at_least "5.00.00.00" \ 479 if ! mysql_version_is_at_least "5.0" \
330 && useq "raid" \ 480 && useq "raid" \
331 && useq "static" ; then 481 && useq "static" ; then
332 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 482 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
333 eerror "with RAID support enabled." 483 eerror "with RAID support enabled."
334 die "USE flags 'raid' and 'static' conflict!" 484 die "USE flags 'raid' and 'static' conflict!"
335 fi 485 fi
336 486
337 if mysql_version_is_at_least "4.01.03.00" \ 487 if mysql_version_is_at_least "4.1.3" \
338 && ( useq "cluster" || useq "extraengine" ) \ 488 && ( useq "cluster" || useq "extraengine" ) \
339 && useq "minimal" ; then 489 && useq "minimal" ; then
340 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 490 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
341 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 491 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
342 fi 492 fi
343 493
494 mysql_check_version_range "4.0 to 5.0.99.99" \
495 && useq "berkdb" \
344 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 496 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
345} 497}
346 498
347mysql_src_unpack() { 499mysql_src_unpack() {
348 # Initialize the proper variables first 500 # Initialize the proper variables first
349 mysql_init_vars 501 mysql_init_vars
350 502
351 unpack ${A} 503 unpack ${A}
352 504 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
353 mv -f "${WORKDIR}/${MY_P}${MYSQL_RERELEASE}" "${S}" 505 bitkeeper_fetch
354 cd "${S}" 506 cd "${S}"
507 einfo "running upstream autorun on bk sources"
508 BUILD/autorun.sh
509 else
510 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
511 cd "${S}"
512 fi
355 513
356 # Apply the patches for this MySQL version 514 # Apply the patches for this MySQL version
357 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then 515 EPATCH_SUFFIX="patch"
358 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch 516 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory"
359 fi 517 mysql_mv_patches
518 epatch || die "failed to apply all patches"
360 519
361 # Additional checks, remove bundled zlib 520 # Additional checks, remove bundled zlib
362 rm -f "${S}/zlib/"*.[ch] 521 rm -f "${S}/zlib/"*.[ch]
363 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 522 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
364 rm -f "scripts/mysqlbug" 523 rm -f "scripts/mysqlbug"
365 524
366 # Make charsets install in the right place 525 # Make charsets install in the right place
367 find . -name 'Makefile.am' \ 526 find . -name 'Makefile.am' \
368 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 527 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
369 528
370 # Manage mysqlmanager
371 mysql_version_is_at_least "5.00.15.00" \
372 && sed -i -e "s!@GENTOO_EXT@!!g" \
373 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
374 "${S}/server-tools/instance-manager/Makefile.am"
375
376 if mysql_version_is_at_least "4.01.00.00" ; then 529 if mysql_version_is_at_least "4.1" ; then
377 # Remove what needs to be recreated, so we're sure it's actually done 530 # Remove what needs to be recreated, so we're sure it's actually done
378 find . -name Makefile \ 531 find . -name Makefile \
379 -o -name Makefile.in \ 532 -o -name Makefile.in \
380 -o -name configure \ 533 -o -name configure \
381 -exec rm -f {} \; 534 -exec rm -f {} \;
382 rm -f "ltmain.sh" 535 rm -f "ltmain.sh"
383 rm -f "scripts/mysqlbug" 536 rm -f "scripts/mysqlbug"
384 fi 537 fi
385 538
386 local rebuilddirlist bdbdir d 539 local rebuilddirlist d
387 540
388 if mysql_version_is_at_least "5.01.00.00" ; then 541 if mysql_version_is_at_least "5.1.12" ; then
389 rebuilddirlist=". storage/innobase" 542 rebuilddirlist="."
390 bdbdir='storage/bdb/dist' 543 # TODO IMPO! Check this with a cmake expert
544 useq "innodb" \
545 && cmake \
546 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \
547 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \
548 "storage/innobase"
391 else 549 else
392 rebuilddirlist=". innobase" 550 rebuilddirlist=". innobase"
393 bdbdir='bdb/dist'
394 fi 551 fi
395 552
396 for d in ${rebuilddirlist} ; do 553 for d in ${rebuilddirlist} ; do
397 einfo "Reconfiguring dir '${d}'" 554 einfo "Reconfiguring dir '${d}'"
398 pushd "${d}" &>/dev/null 555 pushd "${d}" &>/dev/null
399 AT_GNUCONF_UPDATE="yes" eautoreconf 556 AT_GNUCONF_UPDATE="yes" eautoreconf
400 popd &>/dev/null 557 popd &>/dev/null
401 done 558 done
402 559
403 # Berkeley DB has been removed in MySQL 5.1
404 if useq "berkdb" \
405 && mysql_check_version_range "4.01.00.00 to 5.00.99.99" ; then 560 if mysql_check_version_range "4.1 to 5.0.99.99" \
561 && useq "berkdb" ; then
406 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh" 562 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
407 pushd "${bdbdir}" \ 563 pushd "bdb/dist" \
408 && sh s_all \ 564 && sh s_all \
409 || die "Failed bdb reconfigure" \ 565 || die "Failed bdb reconfigure" \
410 &>/dev/null 566 &>/dev/null
411 popd &>/dev/null 567 popd &>/dev/null
412 fi 568 fi
414 570
415mysql_src_compile() { 571mysql_src_compile() {
416 # Make sure the vars are correctly initialized 572 # Make sure the vars are correctly initialized
417 mysql_init_vars 573 mysql_init_vars
418 574
575 # $myconf is modified by the configure_* functions
419 local myconf 576 local myconf=""
420 577
421 if useq "static" ; then
422 myconf="${myconf} --with-mysqld-ldflags=-all-static"
423 myconf="${myconf} --with-client-ldflags=-all-static"
424 myconf="${myconf} --disable-shared"
425 else
426 myconf="${myconf} --enable-shared --enable-static"
427 fi
428
429 myconf="${myconf} --without-libwrap"
430
431 if useq "ssl" ; then 578 if useq "minimal" ; then
432 # --with-vio is not needed anymore, it's on by default and 579 configure_minimal
433 # has been removed from configure 580 else
434 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 581 configure_common
435 if mysql_version_is_at_least "5.00.06.00" ; then 582 if mysql_version_is_at_least "5.1.10" ; then
436 # yassl-0.96 is still young and breaks with GCC-4.X or amd64 583 configure_51
437 # myconf="${myconf} --with-yassl"
438 myconf="${myconf} --with-openssl"
439 else 584 else
440 myconf="${myconf} --with-openssl" 585 configure_40_41_50
441 fi
442 else
443 myconf="${myconf} --without-openssl"
444 fi
445
446 if useq "debug" ; then
447 myconf="${myconf} --with-debug=full"
448 else
449 myconf="${myconf} --without-debug"
450
451 mysql_version_is_at_least "4.01.03.00" && useq "cluster" \
452 && myconf="${myconf} --without-ndb-debug"
453 fi
454
455 # These are things we exclude from a minimal build.
456 # Note that the server actually does get built and installed,
457 # but we then delete it.
458 local minimal_exclude_list="server embedded-server extra-tools innodb bench"
459
460 if ! useq "minimal" ; then
461 myconf="${myconf} --with-server"
462 myconf="${myconf} --with-extra-tools"
463
464 if ! mysql_version_is_at_least "5.00.00.00" ; then
465 if useq "raid" ; then
466 myconf="${myconf} --with-raid"
467 else
468 myconf="${myconf} --without-raid"
469 fi 586 fi
470 fi
471
472 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
473 myconf="${myconf} --with-charset=utf8"
474 myconf="${myconf} --with-collation=utf8_general_ci"
475 else
476 myconf="${myconf} --with-charset=latin1"
477 myconf="${myconf} --with-collation=latin1_swedish_ci"
478 fi
479
480 # Optional again with MySQL 5.1
481 if mysql_version_is_at_least "5.01.00.00" ; then
482 if useq "innodb" ; then
483 myconf="${myconf} --with-innodb"
484 else
485 myconf="${myconf} --without-innodb"
486 fi
487 fi
488
489 # Lots of charsets
490 myconf="${myconf} --with-extra-charsets=all"
491
492 # The following fix is due to a bug with bdb on SPARC's. See:
493 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
494 # It comes down to non-64-bit safety problems.
495 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
496 elog "Berkeley DB support was disabled due to incompatible arch"
497 myconf="${myconf} --without-berkeley-db"
498 else
499 # TODO: berkdb in MySQL 5.1 needs to be worked on
500 if useq "berkdb" && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
501 myconf="${myconf} --with-berkeley-db=./bdb"
502 else
503 myconf="${myconf} --without-berkeley-db"
504 fi
505 fi
506
507 if mysql_version_is_at_least "4.01.03.00" ; then
508 myconf="${myconf} --with-geometry"
509
510 if useq "cluster" ; then
511 myconf="${myconf} --with-ndbcluster"
512 else
513 myconf="${myconf} --without-ndbcluster"
514 fi
515 fi
516
517 if useq "big-tables" ; then
518 myconf="${myconf} --with-big-tables"
519 else
520 myconf="${myconf} --without-big-tables"
521 fi
522
523 mysql_version_is_at_least "5.01.06.00" \
524 && myconf="${myconf} --with-ndb-binlog"
525
526 if useq "embedded" ; then
527 myconf="${myconf} --with-embedded-privilege-control"
528 myconf="${myconf} --with-embedded-server"
529 else
530 myconf="${myconf} --without-embedded-privilege-control"
531 myconf="${myconf} --without-embedded-server"
532 fi
533
534 # Benchmarking stuff needs Perl
535 if useq "perl" ; then
536 myconf="${myconf} --with-bench"
537 else
538 myconf="${myconf} --without-bench"
539 fi
540 else
541 for i in ${minimal_exclude_list} ; do
542 myconf="${myconf} --without-${i}"
543 done
544 myconf="${myconf} --without-berkeley-db"
545 myconf="${myconf} --with-extra-charsets=none"
546 fi
547
548 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
549 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
550 myconf="${myconf} --with-archive-storage-engine"
551
552 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
553 myconf="${myconf} --with-csv-storage-engine"
554
555 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
556 myconf="${myconf} --with-blackhole-storage-engine"
557
558 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
559 # http://dev.mysql.com/doc/mysql/en/federated-description.html
560 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
561 if mysql_version_is_at_least "5.00.03.00" ; then
562 elog "Before using the Federated storage engine, please be sure to read"
563 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
564 myconf="${myconf} --with-federated-storage-engine"
565 fi
566
567 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
568 if mysql_version_is_at_least "5.01.00.00" ; then
569 myconf="${myconf} --with-partition"
570 fi
571 fi
572
573 mysql_version_is_at_least "5.00.18.00" \
574 && useq "max-idx-128" \
575 && myconf="${myconf} --with-max-indexes=128"
576
577 mysql_version_is_at_least "5.01.05.00" \
578 && myconf="${myconf} --with-row-based-replication"
579
580 # TODO: Rechek again later, there were problems with assembler enabled
581 # and some combination of USE flags with MySQL 5.1
582 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
583 myconf="${myconf} --disable-assembler"
584 else
585 myconf="${myconf} --enable-assembler"
586 fi 587 fi
587 588
588 # Bug #114895, bug #110149 589 # Bug #114895, bug #110149
589 filter-flags "-O" "-O[01]" 590 filter-flags "-O" "-O[01]"
590 591
591 # glib-2.3.2_pre fix, bug #16496 592 # glib-2.3.2_pre fix, bug #16496
592 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 593 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
593 594
594 append-flags "-fno-exceptions -fno-strict-aliasing" 595 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
595 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 596 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
596 mysql_version_is_at_least "5.00.00.00" \ 597 mysql_version_is_at_least "5.0" \
597 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 598 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
598 export CXXFLAGS 599 export CXXFLAGS
599 600
600 econf \ 601 econf \
602 --program-suffix="${MY_SUFFIX}" \
601 --libexecdir="/usr/sbin" \ 603 --libexecdir="/usr/sbin" \
602 --sysconfdir="${MY_SYSCONFDIR}" \ 604 --sysconfdir="${MY_SYSCONFDIR}" \
603 --localstatedir="${MY_LOCALSTATEDIR}" \ 605 --localstatedir="${MY_LOCALSTATEDIR}" \
604 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 606 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
605 --libdir="${MY_LIBDIR}" \ 607 --libdir="${MY_LIBDIR}" \
606 --includedir="${MY_INCLUDEDIR}" \ 608 --includedir="${MY_INCLUDEDIR}" \
607 --with-low-memory \ 609 --with-low-memory \
608 --enable-local-infile \
609 --with-mysqld-user=mysql \
610 --with-client-ldflags=-lstdc++ \ 610 --with-client-ldflags=-lstdc++ \
611 --enable-thread-safe-client \ 611 --enable-thread-safe-client \
612 --with-comment="Gentoo Linux ${PF}" \ 612 --with-comment="Gentoo Linux ${PF}" \
613 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \
614 --without-readline \
615 --without-docs \ 613 --without-docs \
616 ${myconf} || die "econf failed" 614 ${myconf} || die "econf failed"
617 615
618 # TODO: Move this before autoreconf !!! 616 # TODO: Move this before autoreconf !!!
619 find . -type f -name Makefile -print0 \ 617 find . -type f -name Makefile -print0 \
620 | xargs -0 -n100 sed -i \ 618 | xargs -0 -n100 sed -i \
621 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 619 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
622 620
623 emake || die "emake failed" 621 emake || die "emake failed"
622
623 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile
624} 624}
625 625
626mysql_src_install() { 626mysql_src_install() {
627 # Make sure the vars are correctly initialized 627 # Make sure the vars are correctly initialized
628 mysql_init_vars 628 mysql_init_vars
629 629
630 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 630 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die
631
632 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install
631 633
632 insinto "${MY_INCLUDEDIR}" 634 insinto "${MY_INCLUDEDIR}"
633 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 635 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
634 636
635 # Convenience links 637 # Convenience links
636 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 638 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}"
637 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 639 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}"
638 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize" 640 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}"
639 641
640 # Various junk (my-*.cnf moved elsewhere) 642 # Various junk (my-*.cnf moved elsewhere)
641 rm -Rf "${D}/usr/share/info" 643 rm -Rf "${D}/usr/share/info"
642 for removeme in "mysql-log-rotate" mysql.server* \ 644 for removeme in "mysql-log-rotate" mysql.server* \
643 binary-configure* my-*.cnf mi_test_all* 645 binary-configure* my-*.cnf mi_test_all*
644 do 646 do
645 rm -f "${D}"/usr/share/mysql/${removeme} 647 rm -f "${D}"/usr/share/mysql/${removeme}
646 done 648 done
647 649
650 # TODO change at Makefile-am level
651 if [[ ${PN} == "mysql-slotted" ]] ; then
652 for moveme in "mysql_fix_privilege_tables.sql" \
653 "fill_help_tables.sql" "ndb-config-2-node.ini"
654 do
655 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
656 done
657 fi
658
648 # Clean up stuff for a minimal build 659 # clean up stuff for a minimal build
649 if useq "minimal" ; then 660 if useq "minimal" ; then
650 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 661 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
651 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 662 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
652 rm -f "${D}/usr/sbin/mysqld" 663 rm -f "${D}/usr/sbin/mysqld"
653 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 664 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
654 fi 665 fi
655 666
667 if [[ ${PN} == "mysql-slotted" ]] ; then
668 local notcatched=$(ls "${D}/usr/share/mysql"/*)
669 if [[ -n "${notcatched}" ]] ; then
670 ewarn "QA notice"
671 ewarn "${notcatched} files in /usr/share/mysql"
672 ewarn "bug mysql-herd to manage them"
673 fi
674 rm -Rf "${D}/usr/share/mysql"
675 fi
676
656 # Configuration stuff 677 # Configuration stuff
657 if mysql_version_is_at_least "4.01.00.00" ; then 678 if mysql_version_is_at_least "4.1" ; then
658 mysql_mycnf_version="4.1" 679 mysql_mycnf_version="4.1"
659 else 680 else
660 mysql_mycnf_version="4.0" 681 mysql_mycnf_version="4.0"
661 fi 682 fi
662 insinto "${MY_SYSCONFDIR}" 683 insinto "${MY_SYSCONFDIR}"
663 doins "scripts/mysqlaccess.conf" 684 doins scripts/mysqlaccess.conf
685 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
664 sed -e "s!@DATADIR@!${DATADIR}!g" \ 686 -e "s!@DATADIR@!${DATADIR}!g" \
665 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 687 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
666 > "${TMPDIR}/my.cnf.ok" 688 > "${TMPDIR}/my.cnf.ok"
667 if mysql_version_is_at_least "4.01.00.00" && useq "latin1" ; then 689 if mysql_version_is_at_least "4.1" && useq "latin1" ; then
668 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 690 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
669 fi 691 fi
670 newins "${TMPDIR}/my.cnf.ok" my.cnf 692 newins "${TMPDIR}/my.cnf.ok" my.cnf
671
672 insinto "/etc/conf.d"
673 newins "${FILESDIR}/mysql.conf.d" "mysql"
674 mysql_version_is_at_least "5.00.11.00" \
675 && newins "${FILESDIR}/mysqlmanager.conf.d" "mysqlmanager"
676 693
677 # Minimal builds don't have the MySQL server 694 # Minimal builds don't have the MySQL server
678 if ! useq "minimal" ; then 695 if ! useq "minimal" ; then
679 exeinto "/etc/init.d"
680 newexe "${FILESDIR}/mysql.rc6" "mysql"
681 mysql_version_is_at_least "5.00.11.00" \
682 && newexe "${FILESDIR}/mysqlmanager.rc6" "mysqlmanager"
683
684 insinto "/etc/logrotate.d"
685 newins "${FILESDIR}/logrotate.mysql" "mysql"
686
687 # Empty directories ... 696 # Empty directories ...
688 diropts "-m0750" 697 diropts "-m0750"
689 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 698 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
690 dodir "${DATADIR}" 699 dodir "${DATADIR}"
691 keepdir "${DATADIR}" 700 keepdir "${DATADIR}"
718 for script in scripts/mysql* ; do 727 for script in scripts/mysql* ; do
719 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 728 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
720 done 729 done
721 fi 730 fi
722 731
723 ROOT="${D}" mysql_lib_symlinks 732 if [[ ${PN} == "mysql-slotted" ]] ; then
733 # MOVED HERE DUE TO BUG #121445
734 # create a list of files, to be used
735 # by external utilities
736 mkdir -p "${D}/var/lib/eselect/mysql/"
737 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
738 pushd "${D}/" &>/dev/null
739 find usr/bin/ usr/sbin/ \
740 -type f -name "*${MY_SUFFIX}*" \
741 -and -not -name "mysql_config${MY_SUFFIX}" \
742 > "${filelist}"
743 find usr/share/man \
744 -type f -name "*${MY_SUFFIX}*" \
745 | sed -e 's/$/.gz/' \
746 >> "${filelist}"
747 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
748 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
749 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
750 popd &>/dev/null
751 fi
724} 752}
725 753
726mysql_pkg_preinst() { 754mysql_pkg_preinst() {
727 enewgroup mysql 60 || die "problem adding 'mysql' group" 755 enewgroup mysql 60 || die "problem adding 'mysql' group"
728 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 756 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
739 # Secure the logfiles 767 # Secure the logfiles
740 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 768 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
741 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 769 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
742 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 770 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
743 771
772 # Minimal builds don't have the MySQL server
744 if ! useq "minimal" ; then 773 if ! useq "minimal" ; then
745 # Your friendly public service announcement ... 774 docinto "support-files"
746 einfo 775 for script in \
747 elog "You might want to run:" 776 support-files/my-*.cnf \
748 elog "\"emerge --config =${CATEGORY}/${PF}\"" 777 support-files/magic \
749 elog "if this is a new install." 778 support-files/ndb-config-2-node.ini
750 einfo 779 do
751 mysql_version_is_at_least "5.01.00.00" \ 780 dodoc "${script}"
752 || elog "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream." 781 done
782
783 docinto "scripts"
784 for script in scripts/mysql* ; do
785 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
786 done
753 fi 787 fi
788
789 einfo "you may want to read slotting upgrade documents in the overlay"
790 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
791 # TODO tell it better ;-)
792 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
793 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
794 einfo "if, after that you cannot start the mysql server"
795 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
796 einfo "use the mysql upgrade script to restore the table"
797 einfo " or "
798 einfo "CREATE TABLE IF NOT EXISTS plugin ("
799 einfo " name char(64) binary DEFAULT '' NOT NULL,"
800 einfo " dl char(128) DEFAULT '' NOT NULL,"
801 einfo " PRIMARY KEY (name)"
802 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;"
803 fi
804 mysql_check_version_range "4.0 to 5.0.99.99" \
805 && useq "berkdb" \
754 useq "berkdb" && elog "Berkeley DB support is deprecated and will be removed in future versions!" 806 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
755} 807}
756 808
757mysql_pkg_config() { 809mysql_pkg_config() {
758 # Make sure the vars are correctly initialized 810 # Make sure the vars are correctly initialized
759 mysql_init_vars 811 mysql_init_vars
760 812
761 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 813 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR"
762 814
763 if built_with_use dev-db/mysql minimal ; then 815 if built_with_use ${CATEGORY}/${PN} minimal ; then
764 die "Minimal builds do NOT include the MySQL server" 816 die "Minimal builds do NOT include the MySQL server"
765 fi 817 fi
766 818
767 local pwd1="a" 819 local pwd1="a"
768 local pwd2="b" 820 local pwd2="b"
804 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 856 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \
805 || die "MySQL databases not installed" 857 || die "MySQL databases not installed"
806 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 858 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null
807 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 859 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null
808 860
809 if mysql_version_is_at_least "4.01.03.00" ; then 861 if mysql_version_is_at_least "4.1.3" ; then
810 options="--skip-ndbcluster" 862 options="--skip-ndbcluster"
811 863
812 # Filling timezones, see 864 # Filling timezones, see
813 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 865 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
814 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 866 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
863 wait %1 915 wait %1
864 einfo "Done" 916 einfo "Done"
865} 917}
866 918
867mysql_pkg_postrm() { 919mysql_pkg_postrm() {
920 if [[ ${PN} == "mysql-slotted" ]] ; then
868 mysql_lib_symlinks 921 mysql_lib_symlinks
922 fi
869} 923}

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.55

  ViewVC Help
Powered by ViewVC 1.1.20